
/*
Commande de deux servomoteurs à l'aide de 5 Boutons 
destinés à l'orientation Pan/Tilt d'une camera.
Pan =  Panoramique.
Tilt = Inclinaison.
Inversez les fils de commande des servo moteurs si nécessaire (Pin 9 et 10).
Le bouton gauche ramène la caméra à une position prédéterminée (ici x 90° / y 90°)

F5MNA  mars 2013  ( Mon site http://f5mna.free.fr )
V 02   avril 2013 
*/
#include <Servo.h>;  //inclu Servo.h 

Servo Pan;           //Déclaration des servos Pan et Tilt
Servo Tilt;   
int   valP;          //variables pour la lecture des potentiomètres
int   valT;

int sensorValue = 0; // Pavé bouton
int sensorPin = A0;  // Assigne pin A0 pour l'entrée du pavé de 5 boutons
word val_key;

void setup()
{
 Pan.attach(9);     //assigne pin 9 et 10 pour le signal de sortie destiné à commander les servos
 Tilt.attach(10);
 Serial.begin(9600); 
 valP = 90;
 valT = 90;
}

void loop ()                              //boucle 
{ 
  
  delay(30);   //Temporisation de l'avance des servos 
  
  sensorValue = analogRead(sensorPin); // lecture d'un bouton  
  val_key = int(sensorValue/100); // valeur entière du bouton / 10  
  
  switch (val_key) {
  //Télécommande:
  //Les valeurs (val_key) 1,3,0,5,7, qui résultent de l'appui sur chacun des boutons
  //peuvent être interverties en fonction des boutons choisis pour assurer la fonction
  
  case 1:     //Bouton Haut
  valT = valT ++ ; 
  if (valT > 175) (valT = 175); 
  break;
  
  case 3:  //Bouton Bas
  valT = valT -- ;   
  if (valT < 5) (valT = 5);
  break;
   
  case 0:  //Bouton Droite
  valP = valP ++ ; 
  if (valP > 175) (valP = 175);
  break;
  
  case 5:  //Bouton Gauche
  valP = valP -- ; 
  if (valP < 5) (valP = 5);
  break;
  
 
  case 7:  //Bouton Select: accés position préselectionnée
  
  if (valP != 90) {
  if (valP < 90) {
    valP ++ ;
   }
    if (valP > 90) {
    valP -- ;
  }
  }
  
  if (valT != 90)  {
    if (valT < 90) {
    valT ++ ;
  }
    if (valT > 90) {
    valT -- ;
  }
  }

  break; 
  }

Pan.write(valP);                          //Donne au servo Pan la valeur à atteindre en degrés
Tilt.write(valT); 

 Serial.print ("X: ");
 Serial.print (valP);
 Serial.print ("Y: ");
 Serial.println (valT);
 
}
